/*! ********************************************
 * SMFTrackEvent.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.smf
{
import flash.utils.ByteArray;

public class SMFTrackEvent
{
	public var next      :SMFTrackEvent = null;
	public var deltaTime :int = 0;
	
	public var type      :int = 0x80;
	public var channel   :int = 0;
	public var value0    :int = 0;
	public var value1    :int = 0;
	
	public var data      :ByteArray = null;
	//public var dataSize  :int = 0;
// Constructor
	public function clear():void
	{
		next = null;
		deltaTime = 0;
		
		type = 0x80;
		channel = 0;
		value0 = 0;
		value1 = 0;
		data = null;
		//dataSize = 0;
	}
	public function SMFTrackEvent(deltaTime:int = 0, type:int = 0x80, ch:int = 0, val0:int = 0, val1:int = 0):void
	{
		if (type == 0x90 && val1 == 0) type = 0x80; // [ noteOn & 0 velocity ] to [ noteOff ]
		this.deltaTime = deltaTime;
		this.type = type;
		this.channel = ch;
		this.value0 = val0;
		this.value1 = val1;
	}
}
}