/*! ********************************************
 * SamplerPreset.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth
{
public class SamplerPreset
{
	public var toneName	:String = "default preset";
	public var smplNum	:int = 0;    // 0 - 127
	public var pan		:int = 64;   // 0 - 127
	public var octv		:int = 8;    // 0 - 15     // center 8, octave = 1
	public var tune		:int = 8192; // 0 - 16383  // center 8192, octave = 8192
	public var tl		:int = 0;    // 0 - 127
	public var ar		:int = 127;  // 0 - 127
	public var dr		:int = 0;    // 0 - 127
	public var sl		:int = 127;  // 0 - 127
	public var rr		:int = 120;  // 0 - 127
	
	public function copy(preset:SamplerPreset):void
	{
		toneName = preset.toneName;
		smplNum = preset.smplNum;
		pan = preset.pan;
		octv = preset.octv;
		tune = preset.tune;
		tl = preset.tl;
		ar = preset.ar;
		dr = preset.dr;
		sl = preset.sl;
		rr = preset.rr;
	}
	public function reset():void
	{
		toneName = "default preset";
		smplNum = 0;
		pan = 64;
		octv = 8;
		tune = 8192;
		tl = 0;
		ar = 127;
		dr = 0;
		sl = 127;
		rr = 120;
	}
// Constructor
	public function SamplerPreset():void{}
}
}