/*! ********************************************
 * TonePresetPCM.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth
{
public class TonePresetPCM
{
// Inastance -----
	public var toneName	:String = "  default preset";
	public var lfoFreq	:int = 2048; // 0 - 16383   LFO - Phase Update Timer Parameter
	public var strc		:int = 0;    // 0 - 3
	public var tune		:int = 8192; // 0 - 16383   center 8192, octave = 8192
	public var lms		:int = 0;    // 0 - 15      LFO - Modulation Depth Senstivity
	public var smplNum	:int = 0;    // 0 - 127
	public var tl		:int = 0;    // 0 - 127
	public var ar		:int = 126;  // 0 - 127
	public var dr		:int = 100;  // 0 - 127
	public var sl		:int = 0;    // 0 - 127
	public var rr		:int = 120;  // 0 - 127
	public var kf		:int = 0;    // 0 - 3       Key Follow Sensitivity         *Instrument 
	public var kfStart	:int = 48;   // 0 - 127     Key Number - Start Key Follow  *Instrument
// Method
	public function copy(preset:TonePresetPCM):void
	{
		toneName = preset.toneName;
		strc = preset.strc;
		smplNum = preset.smplNum;
		tune = preset.tune;
		
		kf = preset.kf;
		kfStart = preset.kfStart;
		
		tl = preset.tl;
		ar = preset.ar;
		dr = preset.dr;
		sl = preset.sl;
		rr = preset.rr;
		
		lms = preset.lms;
		lfoFreq = preset.lfoFreq;
	}
	public function reset():void
	{
		toneName = "default preset";
		lfoFreq = 2048;
		strc = 0;
		tune = 8192;
		lms = 0;
		smplNum = 0;
		tl = 0;
		ar = 126;
		dr = 100;
		sl = 0;
		rr = 120;
		kf = 0;
		kfStart	= 48;
	}
// Constructor
	public function TonePresetPCM():void{}
}
}