/*! ********************************************
 * VoicePart.as
 * Copyright 2019 masahiro takamoto (MotChan)
 * Distributed under the MIT license. 
 * see -> sora/license.txt
 ******************************************** */
package sora.graybox.synth
{
public class VoicePart
{
	// status
	internal var mode        :int = 0;
	internal var defaultMode :int = 0;
	//public var tune          :int = 0;
	//public var keyShift      :int = 0;
	//public var efxSend       :Boolean = false;
	//public var efxMix        :Number = 0;
	//public var volumeTableNum :int = 0;
	//public var panTableNum    :int = 0;
	//public var ch             :int = 0;
	// Parameter
	public var programChange:int = 0;
	public var chPressure   :int = 0;
	public var pitchBend    :int = 8192;
	public var ccValues     :Vector.<int> = new Vector.<int>(120, true);
	// Extra
	public var bendSens :int = 2;
	public var extVal0  :int = 0;
	public var extVal1  :int = 0;
	/*
	- RPN,NRPN -
		         [FE DCBA987 6543210]
		value -> [dc bbbbbbb aaaaaaa]
		a = RPN,NRPN (LSB)
		b = RPN,NRPN (MSB)
		c = Flag (Received LSB)
		d = Flag (Received MSB)
			
		paramNumber -> RPN[0-127], NRPN[128-255], nullRPN[256]
		value <= 100h [100h : null RPN] 
	*/
	internal var rpn         :int = 0;
	internal var nrpn        :int = 0;
	internal var paramNumber :int = 0x100;
	
	public function reset():void
	{
		programChange = 0;
		chPressure    = 0;
		pitchBend     = 8192;
		bendSens      = 2;
		
		for (var i:int = 0; i < 120; i++) ccValues[i] = 0;
		ccValues[ 1] = 0;
		ccValues[ 7] = 100;
		ccValues[10] = 64;
		ccValues[11] = 127;
		
		rpn         = 0;
		nrpn        = 0;
		paramNumber = 0x100;
		
		extVal0 = 0;
		extVal1 = 0;
	}
	internal function resetAllControlle():void
	{
		chPressure   = 0;
		pitchBend    = 8192;
		
		ccValues[ 1] = 0;
		ccValues[11] = 127;
		
		rpn         = 0;
		nrpn        = 0;
		paramNumber = 0x100;
	}
	internal function resetRPNControlle():void
	{
		rpn         = 0;
		nrpn        = 0;
		paramNumber = 0x100;
	}
//constructor
	public function VoicePart(defaultMode:int = 0):void
	{
		this.defaultMode = defaultMode;
		mode = defaultMode;
		reset();
	}
	
}}